/*
 File: parallel_parser_ph_thsym.cpp
 Date and Time: Fri Jan 30 18:55:19 2015 
*/
#include "parallel_parser_ph_th.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_parallel_parser_ph_th;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_parallel_parser_ph_th::TH_parallel_parser_ph_th(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_parallel_parser_ph_th;
  NS_parallel_parser_ph_th::Cparallel_parser_ph_th Cparallel_parser_ph_th_;// parallel-parser's parse table
#define ssPARSE_TABLE Cparallel_parser_ph_th_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_parallel_parser_ph_th::PROC_TH_parallel_parser_ph_th(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_parallel_parser_ph_th";
  static bool one_time(false);
  static NS_parallel_parser_ph_th::Cparallel_parser_ph_th* NS_parallel_parser_ph_th_Cparallel_parser_ph_th_(0);// parallel-parser's fsm table
  static Parser* NS_parallel_parser_ph_th_Cparallel_parser_ph_th_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_parallel_parser_ph_th_Cparallel_parser_ph_th_ = new NS_parallel_parser_ph_th::Cparallel_parser_ph_th();// parallel-parser's fsm table
    NS_parallel_parser_ph_th_Cparallel_parser_ph_th_parser = new Parser(*NS_parallel_parser_ph_th_Cparallel_parser_ph_th_,Caller_pp);
  }
 proc_parser = NS_parallel_parser_ph_th_Cparallel_parser_ph_th_parser;
#include "wproc_pp_core.h"
}
void 
Cparallel_parser_ph_th::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rparallel_parser_phrase_:{
       Rparallel_parser_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_parser_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_parser_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 6;
    

     sym->sr1();
     return;}
    case rhs1_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rlint_:{
       Rlint* sym;
     if(re->rule_ == 0){
       sym = new Rlint(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlint*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs1_Ropen_par_:{
       Ropen_par* sym;
     if(re->rule_ == 0){
       sym = new Ropen_par(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_par*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Ropen_par_:{
       Ropen_par* sym;
     if(re->rule_ == 0){
       sym = new Ropen_par(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ropen_par*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rclose_par_:{
       Rclose_par* sym;
     if(re->rule_ == 0){
       sym = new Rclose_par(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_par*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Rclose_par_:{
       Rclose_par* sym;
     if(re->rule_ == 0){
       sym = new Rclose_par(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rclose_par*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rparameters_:{
       Rparameters* sym;
     if(re->rule_ == 0){
       sym = new Rparameters(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparameters*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rpp_thread_fnct_phrase_:{
       Rpp_thread_fnct_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rpp_thread_fnct_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_thread_fnct_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 6;
    

     sym->sr1();
     return;}
    case rhs1_Rpp_thread_fnct_:{
       Rpp_thread_fnct* sym;
     if(re->rule_ == 0){
       sym = new Rpp_thread_fnct(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_thread_fnct*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rpp_thread_fnct_:{
       Rpp_thread_fnct* sym;
     if(re->rule_ == 0){
       sym = new Rpp_thread_fnct(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_thread_fnct*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rpp_thread_fnct_:{
       Rpp_thread_fnct* sym;
     if(re->rule_ == 0){
       sym = new Rpp_thread_fnct(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_thread_fnct*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Rpp_thread_fnct_id_:{
       Rpp_thread_fnct_id* sym;
     if(re->rule_ == 0){
       sym = new Rpp_thread_fnct_id(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_thread_fnct_id*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rpp_thread_fnct_id_:{
       Rpp_thread_fnct_id* sym;
     if(re->rule_ == 0){
       sym = new Rpp_thread_fnct_id(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_thread_fnct_id*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rpp_thread_fnct_id_:{
       Rpp_thread_fnct_id* sym;
     if(re->rule_ == 0){
       sym = new Rpp_thread_fnct_id(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_thread_fnct_id*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_R3asterics_:{
       R3asterics* sym;
     if(re->rule_ == 0){
       sym = new R3asterics(parser__);
       re->rule_ = sym;
     }else{
       sym = (R3asterics*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_R3asterics_:{
       R3asterics* sym;
     if(re->rule_ == 0){
       sym = new R3asterics(parser__);
       re->rule_ = sym;
     }else{
       sym = (R3asterics*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    case rhs1_Rpp_la_bndary_phrase_:{
       Rpp_la_bndary_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rpp_la_bndary_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_la_bndary_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 4;
    

     sym->sr1();
     return;}
    case rhs1_Rpp_la_bndary_:{
       Rpp_la_bndary* sym;
     if(re->rule_ == 0){
       sym = new Rpp_la_bndary(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_la_bndary*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rpp_la_bndary_:{
       Rpp_la_bndary* sym;
     if(re->rule_ == 0){
       sym = new Rpp_la_bndary(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_la_bndary*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rpp_la_bndary_:{
       Rpp_la_bndary* sym;
     if(re->rule_ == 0){
       sym = new Rpp_la_bndary(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_la_bndary*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Rpp_la_bndary_stc_:{
       Rpp_la_bndary_stc* sym;
     if(re->rule_ == 0){
       sym = new Rpp_la_bndary_stc(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_la_bndary_stc*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Rpp_la_bndary_stc_:{
       Rpp_la_bndary_stc* sym;
     if(re->rule_ == 0){
       sym = new Rpp_la_bndary_stc(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_la_bndary_stc*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr2();
     return;}
    case rhs3_Rpp_la_bndary_stc_:{
       Rpp_la_bndary_stc* sym;
     if(re->rule_ == 0){
       sym = new Rpp_la_bndary_stc(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rpp_la_bndary_stc*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    default: return;
   }
}
